package jp.co.melco.preserv.misc ;

/*
  
  C[W{^NX

  {\[X́APreSerVJ҃CZXw
  [Ul݂̂gp܂B
  {\[XyуJX^}CY\[X̏Ɨp\łB
  AJX^}CŶɑ΂铮ۏ؂͌eӊ肢܂B

  copyright(c) MITSUBISHI ELECTRIC CORPORATION

*/
import java.awt.image.*;
import java.awt.*;
import java.applet.*;
import java.util.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class Pr_ImageButton extends Canvas implements MouseListener{

    protected Image image = null;

    protected boolean imageSizeKnown = false;

    protected String label;

    protected boolean imageLoaded = false;

    protected int shadow = 2;

    protected int border = 2;

    public boolean selected = false;

    protected boolean resizeImage = true;

    protected boolean showLabel = true;

    protected int  minWidth = 10;

    public Pr_ImageButton(Image image, String label,
		       int shadow, int border,
		       boolean resizeImage,
		       boolean showLabel,
		       int minWidth) {
	this.image = image;
	if (image == null)
	    imageSizeKnown = true;	
	this.label = label;
	this.shadow = shadow;
	this.border = border;
	this.resizeImage = resizeImage;
	this.showLabel = showLabel;
	this.minWidth = minWidth;

	this.addMouseListener(this);
    }

    public Pr_ImageButton(Image image, String label,
		       int shadow, int border,
		       boolean resizeImage,
		       boolean showLabel) {
	this(image, label, shadow, border, resizeImage, showLabel, 10);
    }

    public Pr_ImageButton(Image image, String label,
		       boolean resizeImage,
		       boolean showLabel) {
	this(image, label, 2, 2, resizeImage, showLabel, 10);
    }

    public Pr_ImageButton(Image image, String label) {
	this(image, label, 2, 2, false, false, 10);
    }

    public Pr_ImageButton(String label) {
	this(null, label, 2, 2, false, true, 10);
    }

    public String getLabel() {
        return label;
    }

    public void setLabel(String label) {
	this.label = label;
	layoutParent();
	repaint();
    }

    public Image getImage() {
	return image;
    }

    public void setImage(Image image) {
	this.image = image;
	layoutParent();
	repaint();
    }

    public boolean getResizeImage() {
	return resizeImage;
    }

    public void setResizeImage(boolean resizeImage) {
	this.resizeImage = resizeImage;
	layoutParent();
	repaint();
    }

    public boolean getShowLabel() {
	return showLabel;
    }

    public void setShowLabel(boolean showLabel) {
	this.showLabel = showLabel;
	layoutParent();
	repaint();
    }

    public boolean imageSizeKnown() {
	return imageSizeKnown;
    }

    protected String paramString() {
	return super.paramString() + ",label=" + label;
    }

boolean _imgflg = true;
public void imageStart(){
  _imgflg = true;
  repaint();
}

public void imageStop(){
  _imgflg = false;
}


    public boolean imageUpdate(Image img, int flags,
			       int x, int y, int w, int h) {

	if ((flags & SOMEBITS) != 0) {
	    imageLoaded = true;
	}
	if ((flags & (HEIGHT|WIDTH)) != 0) {
	    imageSizeKnown = true;
	    layoutParent();
	}

	if ((flags & (FRAMEBITS)) != 0 && !_imgflg){
		super.imageUpdate(img, flags, x, y, w, h);
		return false;
	}

	return super.imageUpdate(img, flags, x, y, w, h);
    }

    protected void layoutParent() {
	Container parent = getParent();
	if (parent != null) {
	    parent.doLayout();
	}
    }

    public void paint(Graphics g) {
	Dimension sz = getSize();
	if (isVisible()) {
	    if (isEnabled()) {
		if (selected)
		    paintSelected(g, sz);
		else
		    paintUnSelected(g, sz);
	    }
	    else if (!isEnabled())
		paintDisabled(g, sz);
	}
    }

    protected void paintSelected(Graphics g, Dimension size) {
	Color c = getBackground();
	g.setColor(c);
	draw3DRect(g, 0, 0, size.width, size.height, false);
	drawBody(g, size);
    }

    protected void paintUnSelected(Graphics g, Dimension size) {
	Color c = getBackground();
	g.setColor(c);
	g.fillRect(0, 0, size.width, size.height);
	draw3DRect(g, 0, 0, size.width, size.height, true);
	drawBody(g, size);
    }

    protected void paintDisabled(Graphics g, Dimension size) {
	Color c = getBackground();
	g.setColor(c);
	g.fillRect(0, 0, size.width, size.height);
	draw3DRect(g, 0, 0, size.width, size.height, true);

	drawBody(g, size);
    }

    public void draw3DRect(Graphics g, int x, int y, int width, int height,
			   boolean raised) {
	Color c = g.getColor();
	Color brighter = c.brighter();
	Color darker = c.darker();

	g.setColor(raised ? brighter : darker);
	for (int i=0; i<shadow; i++) {
	    g.drawLine(x+i, y+i, x+width-1-i, y+i);
	    g.drawLine(x+i, y+i, x+i, y+height-1-i);
	}
	g.setColor(raised ? darker : brighter);
	for (int i=0; i<shadow; i++) {
	    g.drawLine(x+i, y+height-1-i, x+width-1-i, y+height-1-i);
	    g.drawLine(x+width-1-i, y+height-1-i, x+width-1-i, y+i);
	}
	g.setColor(c);
    }

    protected void drawBody(Graphics g, Dimension size) {
	int selOff = selected ? 1 : 0;
	int labelX = 0;
	int labelY = 0;
	int labelW = 0;
	int labelH = 0;
	FontMetrics fm = null;
	if (image == null || showLabel) {
	    Font f = getFont();
	    fm = getFontMetrics(f);
	    labelH = fm.getAscent() + fm.getDescent();
	    labelW = fm.stringWidth(label);
	    labelX = size.width/2 - labelW/2 + selOff;
	    labelY = size.height/2 - labelH/2 + fm.getAscent() + selOff;
	}
	if (image != null) {
	    int x, y, w, h;
	    if (resizeImage) {
		x = shadow + border + selOff;
		y = shadow + border + selOff;
		w = size.width - 2*(shadow+border) - selOff;
		h = size.height - 2*(shadow+border) - selOff;
		if (showLabel)
		    h -= (labelH + border);
	    }
	    else {
		Dimension d = new Dimension();
		d.width = image.getWidth(this);
		d.height = image.getHeight(this);
		if (d.width > 0 && d.height > 0)
		    imageSizeKnown = true;
		w = d.width - selOff;
		h = d.height - selOff;
		if (showLabel) {
		    x = size.width/2 - d.width/2 + selOff;
		    y = (size.height - labelH - border - shadow)/2 -
			d.height/2 + selOff;
		}
		else {
		    x = size.width/2 - d.width/2 + selOff;
		    y = size.height/2 - d.height/2 + selOff;
		}
	    }
	    g.drawImage(image, x, y, w, h, this);
	    if (showLabel) {
		if (!isEnabled())
		    g.setColor(Color.gray);
		else
		    g.setColor(getForeground());
		labelY = size.height - fm.getDescent() -
		    border - shadow - selOff;
		g.drawString(label, labelX, labelY);
	    }
	}
	else {
	    if (!isEnabled())
		g.setColor(Color.gray);
	    else
		g.setColor(getForeground());
	    g.drawString(label,  labelX, labelY);
	}
    }

    public Dimension getPreferredSize() {
	return getMinimumSize();
    }

    public Dimension getMinimumSize() {
	Dimension d = new Dimension();
	Dimension labelDimension = new Dimension();
	if (image == null || showLabel) {
	    FontMetrics fm = getFontMetrics(getFont());
	    labelDimension.width =
		Math.max(fm.stringWidth(label) + 2*(shadow+border),
			 minWidth);
	    labelDimension.height = fm.getAscent() + fm.getDescent() +
		2*(shadow+border);
	    if (image == null)
		d = labelDimension;
	}
	if (image != null) {
	    d.width = image.getWidth(this) ;
	    d.height = image.getHeight(this);
	    if (d.width > 0 && d.height > 0) {
		d.width += 2*(shadow+border);
		d.height += 2*(shadow+border);
		d.width = Math.max(d.width, minWidth);
		if (showLabel) {
		    if (labelDimension.width > d.width)
			d.width = labelDimension.width;
		    d.height += labelDimension.height - 2*shadow - border;
		}
	    }
	}
	return d;
    }

    public void setEnabled(boolean b) {
	super.setEnabled(b);
	repaint();		
    }

    public void mouseClicked(MouseEvent ev) {
    }

    public void mouseReleased(MouseEvent ev) {

	if (selected) {
	    selected = false;
	    repaint();
	    AWTEvent  ae = 
		new ActionEvent(this, 
				java.awt.event.ActionEvent.ACTION_PERFORMED, 
				label) ;
	    dispatchEvent(ae) ;
	    
	}
    }

    public void mouseEntered(MouseEvent ev) {
    }

    public void mouseExited(MouseEvent ev) {

	if (selected) {
	    selected = false;
	    repaint();
	}
    }

    public void mousePressed(MouseEvent ev) {
	selected = true;
	repaint();
    }



}
